@JS('AMap')
library amap;

import 'package:js/js.dart';

/**
 * 这里`new Map(id)` 调用js的`new AMap.Map(id)
 * new AMap.Map(div: (String | HTMLDivElement), opts: MapOptions)
 */
@JS('Map')
class AMap {
  external AMap(dynamic /*String|HTMLDivElement*/ div, MapOptions opts);

  /// 加载插件
  external plugin(dynamic /*String|List*/ name, void Function() callback);
}

@JS()
@anonymous
class MapOptions {
  external factory MapOptions({
    // 初始中心经纬度
    LngLat center,
    // 地图显示的缩放级别
    num zoom,
    // 地图视图模式, 默认为‘2D’
    String /*‘2D’|‘3D’*/ viewMode,
  });
}

@JS()
class LngLat {
  external num getLng();

  external num getLat();

  external LngLat(num lng, num lat);
}

@JS('Driving')
class Driving {
  /// 导航
  external Driving(DrivingOptions opts);

  external search(LngLat origin, LngLat destination,
      void Function(String status, dynamic result) callback);
}

@JS()
@anonymous
class DrivingOptions {
  external factory DrivingOptions({
    // 地图实例
    AMap map,
    // 地图显示的缩放级别
    dynamic panel,
  });
}

@JS()
@anonymous
class DrivingResult {
  external String get info;
}
